; Ikayaki Installer
;

;--------------------------------

!include "Sections.nsh"

; The name of the installer
Name "IkayakiDebug"

; The file to write
OutFile "ikayaki-debug-setup.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Ikayaki_Debug

; Other installer settings
SetCompressor lzma

;--------------------------------
;Definitions

!define SHCNE_ASSOCCHANGED 0x8000000
!define SHCNF_IDLIST 0

;--------------------------------
; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------
; The stuff to install

Section "!IkayakiDebug (required)"

  SectionIn RO
  
  IfFileExists $INSTDIR\*.* 0 DoInstall
    MessageBox MB_YESNO "Folder $INSTDIR already exists. Do you want to overwrite it?" IDYES DoInstall IDNO AbortInstall
    AbortInstall:
    MessageBox MB_OK "Installation aborted."
    Quit
  DoInstall:
  
  SetOutPath $INSTDIR
  File "ikayaki-debug.exe"
  File "ikayaki-debug.jar"
  File "LICENCE"
  File /r "lib"
  File /r "jre"
  File /r "manual"
  
  ; File type associations (NOT IN DEBUG VERSION, keep associations to Release Version intact)
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\IkayakiDebug" "DisplayName" "Ikayaki"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\IkayakiDebug" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\IkayakiDebug" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\IkayakiDebug" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\Ikayaki Debug"
  CreateShortCut "$SMPROGRAMS\Ikayaki Debug\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Ikayaki Debug\Ikayaki.lnk" "$INSTDIR\ikayaki-debug.exe" "" "$INSTDIR\ikayaki-debug.exe" 0
  
SectionEnd

Section "Desktop Shortcut"

  CreateShortCut "$DESKTOP\IkayakiDebug.lnk" "$INSTDIR\ikayaki-debug.exe" "" "$INSTDIR\ikayaki-debug.exe" 0
  
SectionEnd

;--------------------------------

; Functions

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove program files
  RMDir /r /REBOOTOK "$INSTDIR\manual"
  RMDir /r /REBOOTOK "$INSTDIR\jre"
  RMDir /r /REBOOTOK "$INSTDIR\lib"
  Delete /REBOOTOK "$INSTDIR\LICENCE"
  Delete /REBOOTOK "$INSTDIR\ikayaki-debug.jar"
  Delete /REBOOTOK "$INSTDIR\ikayaki-debug.exe"
  
  ; Remove file type associations (NOT IN DEBUG VERSION, keep associations to Release Version intact) 
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\IkayakiDebug"

  ; Remove uninstaller
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Ikayaki Debug\*.*"
  Delete "$DESKTOP\IkayakiDebug.lnk"
  
  ; Remove directories used (if empty)
  RMDir "$SMPROGRAMS\Ikayaki Debug"
  RMDir "$INSTDIR"

SectionEnd