; Mavis Installer
;

;--------------------------------

!include "Sections.nsh"

; The name of the installer
Name "Mavis v1.0"

; The file to write
OutFile "mavis-v1.0-setup.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Mavis

; Other installer settings
SetCompressor lzma

;--------------------------------
;Definitions

!define SHCNE_ASSOCCHANGED 0x8000000
!define SHCNF_IDLIST 0

;--------------------------------
; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------
; The stuff to install

Section "!Mavis (required)"

  SectionIn RO

  IfFileExists $INSTDIR\*.* 0 DoInstall
    MessageBox MB_YESNO "Folder $INSTDIR already exists. Do you want to overwrite it?" IDYES DoInstall IDNO AbortInstall
    AbortInstall:
    MessageBox MB_OK "Installation aborted."
    Quit
  DoInstall:

  SetOutPath $INSTDIR
  File "mavis.exe"
  File "mavis.jar"
  File "LICENCE"
  File /r "lib"
  File /r "jre"
  File /r "manual"
  File "jutil.dll"

  ; File type associations
  ; -- not for Mavis

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Mavis" "DisplayName" "Mavis"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Mavis" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Mavis" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Mavis" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\Mavis"
  CreateShortCut "$SMPROGRAMS\Mavis\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Mavis\Mavis.lnk" "$INSTDIR\mavis.exe" "" "$INSTDIR\mavis.exe" 0
  CreateShortCut "$SMPROGRAMS\Mavis\Mavis Manual.lnk" "$INSTDIR\manual\index.html" "" "$INSTDIR\manual\index.html" 0

SectionEnd

Section "Desktop Shortcut"

  CreateShortCut "$DESKTOP\Mavis.lnk" "$INSTDIR\mavis.exe" "" "$INSTDIR\mavis.exe" 0

SectionEnd

;--------------------------------

; Functions

;--------------------------------

; Uninstaller

Section "Uninstall"

  ; Remove program files
  RMDir /r /REBOOTOK "$INSTDIR\manual"
  RMDir /r /REBOOTOK "$INSTDIR\jre"
  RMDir /r /REBOOTOK "$INSTDIR\lib"
  Delete /REBOOTOK "$INSTDIR\LICENCE"
  Delete /REBOOTOK "$INSTDIR\mavis.jar"
  Delete /REBOOTOK "$INSTDIR\mavis.exe"
  Delete /REBOOTOK "$INSTDIR\jutil.dll"


  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Mavis"

  ; Remove uninstaller
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Mavis\*.*"
  Delete "$DESKTOP\Mavis.lnk"

  ; Remove directories used (if empty)
  RMDir "$SMPROGRAMS\Mavis"
  RMDir "$INSTDIR"

SectionEnd