@REM
@REM   IKAYAKI DEPLOYMENT BUILDER FOR DEBUG RELEASES
@REM   ---------------------------------------------
@REM
@REM   Prerequisites: ikayaki has been compiled in/for debug mode
@REM
@REM   Programs required: none (already included in CVS, .\build directory)
@REM
@REM   Does: assembles all files necessary for user deployment into
@REM   the directory 'build', packs ikayaki classes into a .jar file,
@REM   converts the .jar to a .exe
@REM
@REM   Run:  make_DEBUG_installer.bat > assemblyLog.txt
@REM
@REM   01/2006 jw - automated jar, exe creation

@echo on

@REM --- prepare TMP directory with files to go to Ikayaki-debug.jar
rmdir /S /Q build\tmp
mkdir build\tmp
xcopy /y /s /exclude:excluded.txt resources build\tmp\resources\
xcopy /y /s /exclude:excluded.txt docs\manual build\manual\
xcopy /y /s /exclude:excluded.txt classes\ikayaki build\tmp\ikayaki\
xcopy /y /s /exclude:excluded.txt classes\jutil build\tmp\jutil\
echo F | xcopy /y src\IKAYAKI.MF build\tmp\META-INF\MANIFEST.MF

@REM --- prepare the separate JRE, and library directories
mkdir build\lib
mkdir build\jre\bin
mkdir build\jre\lib
copy /y lib\*.jar build\lib\
del build\lib\junit.jar
copy /y lib\*.dll build\jre\bin\
copy /y lib\*.properties build\jre\lib\

@REM --- create .JAR containing only Ikayaki classes (delete hidden .\CVS dir)
cd build\tmp
del /F /Q CVS
rmdir CVS
del *.jar
jar cvf ikayaki-debug.jar *.*
move ikayaki-debug.jar ..

@REM --- use JSmooth to create exe from jar
cd ..
del ikayaki-debug.exe
cd jsmooth-0.9.7
jsmoothcmd.exe ..\ikayaki-debug.jsmooth
cd ..

@echo off
@echo JAR ready!
pause