package ikayaki.squid;

import junit.framework.TestCase;
import ikayaki.Settings;

public class DegausserTest extends TestCase {

    private Degausser degausser1;

    protected void setUp() throws Exception {
        super.setUp();
        Settings.setDegausserPort("COM1");
        Settings.setDegausserDelay(1);
        Settings.setDegausserRamp(3,1);
        Settings.setDegausserMaximumField(120.0);
        degausser1 = new Degausser(); // can't test for port open success/fail...
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public DegausserTest(String name) {
        super(name);
    }

    public void testBuffering() {
        degausser1.serialIOEvent(new SerialIOEvent(this, "DCD1\r\n"));
        degausser1.serialIOEvent(new SerialIOEvent(this, "DCR3\r\n"));
        degausser1.updateSettings();
        //assertFalse(degausser1.waitingForMessage);
        //--test how?? internal state...
    }

    public void testKeepalives() {
        degausser1.serialIOEvent(new SerialIOEvent(this, "DCA1200\r\n"));
        degausser1.serialIOEvent(new SerialIOEvent(this, "DCCZ\r\n"));
        degausser1.serialIOEvent(new SerialIOEvent(this, "DERC\r\n"));
        degausser1.serialIOEvent(new SerialIOEvent(this, "\r\n"));
        degausser1.serialIOEvent(new SerialIOEvent(this, "\r\n"));
        degausser1.serialIOEvent(new SerialIOEvent(this, "DONE\r\n"));
        assertTrue(degausser1.demagnetizeZ(120.0));
        //--test how?? internal state, blocking writes, ...
    }

}
